Program AMD29F0x0_im_ATARI_Portfolio_flashen;

uses dos, portfolio, dspace;

type filerec = array[0..$7fff] of byte;

var
	antwort:char;
	wahl:char;
        dummy:char;
        laufwerk:byte;
	ziel:string[25];
        drivechar:char;
	drivenum:byte;
        special:char;
        zeiger1:char;
        zeiger2:char;
        r:registers;
	i:longint;
        c:longint;
	f:file of filerec;
	data:byte;
	b:integer;
	buf:filerec;
	b1:filerec absolute $c000:0;
	b2:filerec absolute $c800:0;
	b3:filerec absolute $d000:0;
	b4:filerec absolute $d800:0;
        x1:byte;
        y1:byte;
        x2:byte;
        y2:byte;
        Border:byte;
        x:byte;
        y:byte;

const
        ESC=#27;

PROCEDURE adieu;
begin
     clrscr;
     portbox(0,0,39,7,1);
     portbox(2,1,36,6,1);
     portbox(5,2,33,5,1);
     portbox(8,3,30,4,1);
     gotoxy(11,3);
     write('Bye, Bye');
     gotoxy(20,4);
     write('My Bytes');
     portbeep;
     dummy:=readkey;
     clrscr;
     portsetcursormode(2);
     halt
end;

PROCEDURE Eingabe1;
begin
     clrscr;
     portbox(0,0,39,7,1);
     gotoxy(10,0);
     write('AMD 29F0X0-Flashsoft');
     gotoxy(5,2);
     write('[I]mage einlesen/erzeugen');
     gotoxy(5,3);
     write('[L]schen von Flashdrive A:/B:');
     gotoxy(5,4);
     write('[F]lashen auf Flashdrive A:/B:');
     gotoxy(5,5);
     write('[S]pezialfunktionen');
     gotoxy(10,7);
     write('(C)9.2000 S.Kchele');
     repeat;
     antwort:=upcase(readkey);
     until (antwort='I') or (antwort='L') or (antwort='F') or (antwort=ESC) or (antwort='S');
end;

PROCEDURE Eingabe2;
begin
	clrscr;
	portbox(0,0,39,7,1);
	gotoxy(7,0);
	write('Funktion: Auswahl Laufwerk');
	gotoxy(4,3);
	write('Laufwerk [A]: oder [B]: whlen');
	gotoxy(10,5);
	write('Abbruch mit [ESC]');
	repeat;
	wahl:=upcase(readkey);
	until(wahl='A') or (wahl='B') or (wahl=ESC);
end;

PROCEDURE Spezial;
begin
     clrscr;
     portbox(0,0,39,7,1);
     gotoxy(2,0);
     write('Imagename + Ziel/Quelle frei whlen');
     gotoxy(2,1);
     write('Image von [Q]uellaufwerk');
     gotoxy(2,2);
     write('Image auf [Z]iellaufwerk');
     gotoxy(2,3);
     write('Eingabebeispiel: e:\meinfile.obj');
     gotoxy(2,4);
     write('[ESC]=Ende');
     repeat;
     special:=upcase(readkey);
     until(special='Z') or (special='Q') or (special=ESC);
     if special=ESC then adieu;
     gotoxy(2,5);
     write('Eingabe Pfad + Filename');
     {Nur Laufwerksbuchstabe}
     drivechar:=upcase(readkey);
     gotoxy(2,6);
     write(drivechar);
     gotoxy(3,6);
     {Pfad ohne Laufwerksbuchstaben}
     read(ziel);
     if special='Z' then zeiger1:='j';
     if special='Q' then zeiger2:='j';
end;

PROCEDURE Imagelesen;
begin
  clrscr;
  portbox(0,0,39,7,1);
  gotoxy(9,0);
  write('Funktion: Image lesen');
  if driveselect(laufwerk) = false then halt;
  gotoxy(6,2);
  write('Image zu ',drivechar, ziel);
  drivenum := ord(drivechar)-64;
  c:=getfreedrivespace(drivenum);
  gotoxy(8,3);
  write('Platz auf ',drivechar, ': = ', c, ' kB');
  gotoxy(6,4);
  if c<131 then write('Kein Platz fr Imagefile !');
  gotoxy(11,4);
  if c>131 then write('-Taste- = Start');
  dummy:=readkey;
  if dummy=ESC then adieu;
  if c<131 then adieu;
  assign(f,(drivechar+ziel));
  rewrite(f);
  write(f,b1);
  write(f,b2);
  write(f,b3);
  write(f,b4);
  close(f);
  if driveselect(0) = false then halt;
  gotoxy(15,6);
  write('Fertig !');
  portbeep;
  dummy:=readkey;
end;

PROCEDURE Flashloeschen;
begin
  clrscr;
  portbox(0,0,39,7,1);
  gotoxy(8,0);
  write('Funktion: Flash lschen');
  if driveselect(laufwerk) = false then halt;
  gotoxy(2,2);
  write('ACHTUNG: Alle Bnke Ihres AMD 29F0X0');
  gotoxy(2,3);
  write('Flash werden nun komplett gelscht !');
  gotoxy(5,4);
  write('-Taste- = Start(ESC = Abbruch)');
  dummy:=readkey;
  if dummy=ESC then adieu;
  mem[$c000:$9555]:=$aa;
  mem[$c000:$2aaa]:=$55;
  mem[$c000:$9555]:=$80;
  mem[$c000:$9555]:=$aa;
  mem[$c000:$2aaa]:=$55;
  mem[$c000:$9555]:=$10;
  gotoxy(5,5);
  write('Warten bis Flash gelscht ist !');
  repeat
  until mem[$c000:0]=255;
  gotoxy(15,6);
  write('Fertig !');
  portbeep;
  dummy:=readkey;
end;

PROCEDURE Imageflashen;
begin
  clrscr;
  portbox(0,0,39,7,1);
  gotoxy(9,0);
  write('Funktion: Image flashen');
  if driveselect(laufwerk) = false then halt;
  gotoxy(5,1);
  write(drivechar,ziel, ' flashen');
  gotoxy(12,2);
  write('-Taste- = Start');
  dummy:=readkey;

  assign(f,(drivechar+ziel));
  reset(f);

  read(f,buf);
  for i:=0 to $7fff do
  begin
    mem[$c000:$9555]:=$aa;
    mem[$c000:$2aaa]:=$55;
    mem[$c000:$9555]:=$a0;
    mem[$c000:i]:=buf[i];
    repeat until mem[$c000:i] = buf[i];
  end;
  gotoxy(5,3);
  write('32 KB geflasht und berprft');

  read(f,buf);
  for i:=0 to $7fff do
  begin
    mem[$c000:$9555]:=$aa;
    mem[$c000:$2aaa]:=$55;
    mem[$c000:$9555]:=$a0;
    mem[$c800:i]:=buf[i];
    repeat until mem[$c800:i] = buf[i];
  end;
  gotoxy(5,4);
  write('64 KB geflasht und berprft');

  read(f,buf);
  for i:=0 to $7fff do
  begin
    mem[$c000:$9555]:=$aa;
    mem[$c000:$2aaa]:=$55;
    mem[$c000:$9555]:=$a0;
    mem[$d000:i]:=buf[i];
    repeat until mem[$d000:i] = buf[i];
  end;
  gotoxy(5,5);
  write('96 KB geflasht und berprft');

  read(f,buf);
  for i:=0 to $7fff do
  begin
    mem[$c000:$9555]:=$aa;
    mem[$c000:$2aaa]:=$55;
    mem[$c000:$9555]:=$a0;
    mem[$d800:i]:=buf[i];
    repeat until mem[$d800:i] = buf[i];
  end;
  gotoxy(4,6);
  write('128 KB geflasht und berprft');

  close(f);
  if driveselect(0) = false then write('Fehler !');
  gotoxy(7,7);
  write('.....fix und fertig.......');
  portbeep;
  dummy:=readkey;
end;

PROCEDURE PC;
Begin
	write('Dieses Programm luft nur auf dem ATARI Portfolio !');
	write(#7);	
	halt
end;

begin
   if isport=false then PC;
   ziel:=':\ccmimage.bin';
   drivechar:='C';
   portsetcursormode(0);
     Eingabe1;
        if antwort = ESC then adieu;
     Eingabe2;
	if wahl = 'A' then laufwerk:=1;
	if wahl = 'B' then laufwerk:=2;
	if wahl = ESC then adieu;
        if antwort ='S' then Spezial;
	if antwort ='I' then Imagelesen;
	if antwort ='L' then Flashloeschen;
 	if antwort ='F' then Imageflashen;
        if zeiger1 ='j' then Imagelesen;
	if zeiger2 ='j' then Imageflashen;
	adieu;
end.